<?php
// $Id: finder.form.inc,v 1.1.2.11 2009/05/02 07:49:17 danielb Exp $

/**
 * @file
 * The finder form.
 */

/**
 * Function to create finder form.
 */
function finder_form(&$form_state, $finder) {
  $form = array();
  if (!$form_state['storage']['finished']) {
    finder_invoke_finderapi($finder, 'finder_form', $form, $form_state);
    $form_state['storage']['finder'] = $finder;
    $form['#action'] = url($finder->path);
    $form['finder_form'] = array(
      '#weight' => 0,
      '#prefix' => '<div class="finder-form finder-'. $finder->finder_id .'">',
      '#suffix' => '</div>',
    );
    $form['finder_form']['#prefix'] .= $finder->settings['form']['prefix'] ? '<div class="prefix">'. $finder->settings['form']['prefix'] .'</div>' : '';
    $max_weight = 0;
    foreach ((array)$finder->elements as $element) {
      $max_weight = max($max_weight, $element->weight);
      if (isset($form_state['values'][$element->finder_element_id])) {
        $element_default = $form_state['values'][$element->finder_element_id];
      }
      else {
        $element_default = $element->settings['form']['default_value'];
      }
      $form['finder_form'][$element->finder_element_id] = array(
        '#title' => $element->title,
        '#weight' => $element->weight,
        '#description' => $element->description,
        '#prefix' => $element->settings['form']['prefix'],
        '#suffix' => $element->settings['form']['suffix'],
        '#default_value' => $element_default,
        '#required' => $element->settings['form']['required'],
      );
      $module = &$element->element_handler['#module'];
      $handler_function = $module .'_finder_element';
      $handler_function($element, $form['finder_form'][$element->finder_element_id]);
    }
    $form['finder_form']['submit'] = array(
      '#type' => 'submit',
      '#value' => $finder->settings['form']['button_text'],
      '#weight' => $max_weight + 1000,
    );
    $form['finder_form']['#suffix'] = ($finder->settings['form']['suffix'] ? '<div class="suffix">'. $finder->settings['form']['suffix'] .'</div>' : '') . $form['finder_form']['#suffix'];
  }
  return $form;
}

/**
 * Submit function for finder form.
 */
function finder_form_submit($form, &$form_state) {
  $form_state['storage']['values'] = $form_state['values'];
  $form_state['storage']['finished'] = TRUE;
  $finder = &$form_state['storage']['finder'];
  finder_form_state($finder->finder_id, $form_state);
}

/**
 * Helper function for finder form to pass form state to results page.
 */
function finder_form_state($finder_id, $form_state = NULL) {
  static $finder_form_state = NULL;
  if ($form_state) {
    $finder_form_state[$finder_id] = $form_state;
  }
  elseif (isset($_GET['finder'])) {
    $finder_form_state[$finder_id] = $_SESSION['finder'][$_GET['finder']];
  }
  return $finder_form_state[$finder_id];
}
