<?php
// $Id: finder_views_plugin_display_finder.inc,v 1.1.2.12 2009/05/02 07:49:18 danielb Exp $

/**
 * @file
 * Handler for 'finder_views' display.
 */
class finder_views_plugin_display_finder extends views_plugin_display {

  function execute() {
    return $this->view->render($this->display->id);
  }

  function render() {
    return !empty($this->view->result) || !empty($this->view->style_plugin->definition['even empty']) ? $this->view->style_plugin->render($this->view->result) : '';
  }

  function query() {
    $options = $this->get_option('finder_views_options');
    if (!empty($options['keywords'])) {
      $this->view->query->set_where_group($options['combination'], 'finder');
      foreach ($options['keywords'] as $feid => $keyword_array) {
        $keyword_array = (array)$keyword_array;
        if (!empty($keyword_array)) {
          $clauses = array();
          $clause_args = array();
          $alias = $this->view->query->ensure_table($options['field_info'][$feid]['table']);
          $match = finder_placeholder($options['match'], $options['field_info'][$feid]['table'], $options['field_info'][$feid]['field']);
          foreach ($keyword_array as $keyword) {
            $clauses[] = $alias .'.'. $options['field_info'][$feid]['field'] .' '. $match;
            $clause_args[] = $keyword;
          }
          if (!empty($clauses)) {
            $this->view->query->add_where('finder', '('. implode(' OR ', $clauses) .')', $clause_args);
          }
        }

      }
    }
  }

}

