<?php
// $Id: finder_views_plugin_style_php_array_finder.inc,v 1.1.2.12 2009/05/02 07:49:18 danielb Exp $

/**
 * @file
 * Handler for 'finder_views_php_array_finder' style.
 */
class finder_views_plugin_style_php_array_finder extends views_plugin_style {
  function render() {
    $results = array();

    // Group the rows according to the grouping field, if specified.
    $sets = $this->render_grouping($this->view->result, $this->options['grouping']);
    $base_field = $this->view->base_field;
    $field = $this->display->display_options['finder_views_field'];
    if ($field) {
      $field_alias = $this->view->field[$field]->field_alias;
    }
    $options = $this->display->display_options['finder_views_options'];

    foreach ($sets as $title => $records) {
      foreach ($records as $label => $row) {
        $results[$row->{$base_field}]['base_table'] = $options['base_table'];
        $results[$row->{$base_field}]['base_field'] = $base_field;
        $results[$row->{$base_field}][$base_field] = $row->{$base_field};
        $results[$row->{$base_field}]['set'] = $title;
        if ($options['mode'] == 'choices') {
          $results[$row->{$base_field}][$field] = $row->{$field_alias};
          $results[$row->{$base_field}]['field_name'] = $field;
        }
        elseif ($options['mode'] == 'results') {
          $results[$row->{$base_field}]['rendered'] = $this->row_plugin->render($row);
          foreach ($options['field_info'] as $feid => $info) {
            $alias = $this->view->field[$info['field']]->field_alias;
            $results[$row->{$base_field}][$info['field']] = $row->{$alias};
            $results[$row->{$base_field}]['field_names'][$feid] = $info['field'];
          }
        }
        $results[$row->{$base_field}] = (object)$results[$row->{$base_field}];
      }
    }

    return $results;
  }
}